# -*- coding: utf-8 -*-
"""
cellgain analysis module
-------------------------------------------------------------------------------

+-----------------+-------------------------------+---------------------------+
| Author          | Name                          | Creation                  |
+-----------------+-------------------------------+---------------------------+
| Benoit Serra    | cell gain                     | Mon Jun 17 15:29:35 2019  |
+-----------------+-------------------------------+---------------------------+

+-----------------+-------------------------------------+---------------------+
| Contributor     | Name                                | Creation            |
+-----------------+-------------------------------------+---------------------+
| Domingo Alvarez | H4RG-Analysis_PixelCellGain.ipynb   | 06/18/2019          |
+-----------------+-------------------------------------+---------------------+


This module can be found in pydecha/modules/cellgain/cellgain_analysis.py.
Please modify the docstrings accordingly to provide the users a simple and
detailed explanation of your algorithm for this module.

Cellgain
========

The cell gain defines the conversion rate between a voltage variation of VReset
(and hence the number of charges generated by the pixel) and the voltage as
input of the ADC.

Data acquisition
================

To measure the cell gain, the value of VReset for the pixel must be kept constant.
In order to ensure a constant VReset, the RESETEN clock low was set close to
its high value (3.1 V). This value is close enough to the high value of the other
rail, effectively forcing the Pixel Cell to be constantly reseted while reading.

Then, the VReset value is scanned from 0.3 V to 0.9 V by steps of 0.05 V.
Correspondingly, the DSub values have been kept 0.25 V higher than VReset.

Computation
===========

The resulting frame is in Digital Number (DN). This digtial value is the result
of the Analogic to Digital Converter of the NGC.
The ADCs used with the NGC encode the data into 16 bits and have a voltage
range of approx. 8 V [-4.096, 4.096]. It is then possible to convert the data
units from Digital Number to Volts.

All the data extraction is done to a Pandas Dataframe. The extracted data is
the full image mean value, from which the voltage at the ADC entrace is
calculated and the telemetry value of the VRESET provided by NGC. Additionally,
the FITS files timestamps is included in the rows of the dataframe.

Plots
=====

Linear fit to the data
######################

The average value of the array versus the VReset value is then plotted.
Using Numpy and a polynomial fit of first order, the cell gain is then obtained
using the data extracted from the dataframe.

.. todo::

   Plot the variation of the photodiode bias in respect to the VReset value

Analysis block
==============
"""
# IMPORTS
#########################
from astropy.io import fits
import glob
import numpy as np
import matplotlib.pyplot as plt
import methods.pydecha_methods as pdcm
import methods.plot_methods as plotm
from tqdm import tqdm
from classes.analysis_module import analysis

# METHODS & CLASSES
#########################
class module(analysis):
    """Cell gain analysis block

    :param module_name (str): Name of the module as string.
    :param yaml_dict (dict): full dictionnary of the config file.

    :return clean_output(): a cleaned dictionnary with the parameters saved

    The cellgain analysis requires the following parameters in the configuration
    file:

    :param data_path (str): absolute path of where the data is.
    :param adc (dict): information of the ADC [bits (int), range (list)].
    :param fit (dict): fit parameters [fit_start (int), fit_stop (int), fit_unit (str)]
    """
    def start(self):
        """"""
        self.logger.info('Starting cellgain analysis...')
        # noise code goes here
        print('cellgain analysis module')
        data_path = self.module_parameters['data_path']
        preampgain_files = glob.glob(data_path+'/*PixelCellGain.fits')
        self.get_dataset_info(preampgain_files,
                              file_type='FITS',
                              save=True)
        preamp_ref, detector_signal_V, detector_signal_DN = list(), list(), list()
        # tqdm around an iterator will print a progress bar while the loop runs.
        pbar = tqdm(preampgain_files, ascii=True, ncols=60)
        pbar.set_description('CellGain Computation')
        for idx, filename in enumerate(pbar):
            self.logger.info('Loop '+str(idx))
            # Opening files
            file_data, file_hdr = fits.getdata(filename, 0,
                                               header=True)
            self.logger.info(' File used: '+str(filename))
            ADC_conversion = abs(np.diff(self.module_parameters['adc']['range'])/(2**self.module_parameters['adc']['bits']))
            detector_signal_DN.append(np.mean(file_data))
            detector_signal_V.append(np.mean(file_data*ADC_conversion))
            preamp_ref.append(file_hdr['HIERARCH ESO DET CLDC1 DCT5'])

        pinfos = {'x_label': 'VReset voltage [V]',
                  'y_label': 'Average signal [V]',
                  'title': 'Detector signal evolution versus change in DC5 - VReset'}
        self.module_parameters.update(**pinfos)
        fig, ax, gain = plotm.fitline_plot(preamp_ref, detector_signal_V,
                                        **self.module_parameters)

        # Don't save the previous plot for now...

        # print (float(gain)/(1.6*4.047))
        pinfos = {'x_label': 'VReset voltage [V]',
                  'y_label': 'Average signal [DN]',
                  'title': 'Detector signal evolution versus change in DC5 - VReset'}
        self.module_parameters.update(**pinfos)
        fig, ax, cellgain = plotm.fitline_plot(preamp_ref, detector_signal_DN,
                                            **self.module_parameters)
        self.save_fig(fig, 'SignalvsVReset')
        self.save_param('CellGain', float(cellgain))

        self.logger.info('Ending cellgain analysis...')
        return self.clean_output()


# MAIN
#########################
if __name__ == "__main__":
    pass


# GARBAGE
#########################
